
As all open-source projects are, we are indebted to an enormous number of underlying open-source projects, countless contributors, and even more person hours. Without these projects and all who have contributed, SanPy would not be possible.

To contribute to the open-source community, we are following the [FAIR][fair]{target=_blank} principles of software development to promote: **(F)**indability, **(A)**ccessibility, **(I)**nteroperability, and **(R)**eusability.

[fair]: https://en.wikipedia.org/wiki/FAIR_data

With this, our software is designed to be flexible in how it is used.

- From a desktop
- As a downloaded app
- On an existing cloud server
- Deployed by our users as their own cloud server

### Core

 - [Python][Python]{target=_blank} - A programming language that lets you work quickly and integrate systems more effectively.
 - [SciPy][SciPy]{target=_blank} - A Python-based ecosystem of open-source software for mathematics, science, and engineering.
 - [NumPy][NumPy]{target=_blank} - The fundamental package for scientific computing with Python.
 - [Pandas][Pandas]{target=_blank} - A data analysis and manipulation tool.
 - [pyABF][pyABF]{target=_blank} - Package to open Axon Binary Format (ABF) files.
 - [heka_reader][heka_reader]{target=_blank} - To read Heka Data files. Not currently used.
 - [XlsxWriter][XlsxWriter]{target=_blank} - To read and write Microsoft Excel files.

### Desktop Application

 - [PyQt][PyQt]{target=_blank} - Python bindings for The [Qt Company's][Qt]{target=_blank} Qt application framework.
 - [PyQtGraph][pyqtgraph]{target=_blank} - Scientific Graphics and GUI Library for Python (built on PyQt and PySide).
 - [Matplotlib][Matplotlib]{target=_blank} - A comprehensive library for creating static, animated, and interactive visualizations in Python.

### Web application v1

 - [Plotly Python][Plotly]{target=_blank} - Open Source Graphing Library.
 - [Plotly Dash][Dash] - A low-code platform for ML & data science apps.
 - [Dash Bootstrap components][Dash Bootstrap components]{target=_blank} - A a library of Bootstrap components for Plotly Dash.

### Web application v2

 - [Docker][docker]{target=_blank} - Empowering App Development for Developers
 - [NGINX][nginx]{target=_blank} - High Performance Load Balancer, Web Server ...
 - [Flask][flask]{target=_blank} - Web development, one drop at a time.
 - [Vue][vue]{target=_blank} - The progressive Javascript framework.
 - [Bootstrap][bootstrap]{target=_blank} - The world's most popular framework for building responsive, mobile-first sites.

[docker]: https://www.docker.com/
[nginx]: https://www.nginx.com/
[flask]: https://flask.palletsprojects.com/en/2.0.x/
[vue]: https://vuejs.org/
[bootstrap]: https://bootstrap-vue.org/

[Python]: https://www.python.org/
[SciPy]: https://www.scipy.org/
[Pandas]: https://pandas.pydata.org/
[NumPy]: https://www.numpy.org/
[pyABF]: https://github.com/swharden/pyABF
[heka_reader]: https://github.com/campagnola/heka_reader
[TkInter]: https://docs.python.org/3/library/tkinter.html
[PyQt]: https://riverbankcomputing.com/software/pyqt/intro
[Qt]: https://www.qt.io/
[pyqtgraph]: http://www.pyqtgraph.org/
[XlsxWriter]: https://xlsxwriter.readthedocs.io/
[Matplotlib]: https://matplotlib.org/
[Plotly]: https://plot.ly/python/
[Dash]: https://plot.ly/products/dash/
[Dash Bootstrap components]: https://dash-bootstrap-components.opensource.faculty.ai/

### Development

 - [pyenv][pyenv]{target=_blank} - Python version management.
 - [mkdocs][mkdocs]{target=_blank} - Static site generator geared towards building project documentation.
 - [mkdocs-material]{target=_blank} - Standardized theme for MkDocs
 - [mkdocstrings][mkdocstrings]{target=_blank} - Automatic documentation from sources, for MkDocs.

[pyenv]: https://github.com/pyenv/pyenv
[mkdocs]: https://www.mkdocs.org/
[mkdocs-material]: https://squidfunk.github.io/mkdocs-material/
[mkdocstrings]: https://mkdocstrings.github.io/

### Other existing analysis software

These is of course other software to do similar things. This is not a complete list.

 - [ParamAP][ParamAP]{target=_blank} - Standardized parameterization of sinoatrial node myocyte action potentials
 - [stimfit][stimfit]{target=_blank} - A program for viewing and analyzing electrophysiological data

C++ libraries

 - [biosig][biosig]{target=_blank} - A C/C++ library providing reading and writing routines for biosignal data formats
 - [sigviewer][sigviewer]{target=_blank} - SigViewer is a viewing application for biosignals.


[ParamAP]: https://github.com/christianrickert/ParamAP
[stimfit]: https://github.com/neurodroid/stimfit
[biosig]: http://biosig.sourceforge.net/projects.html
[sigviewer]: https://github.com/cbrnr/sigviewer
